#include "libgccvb.h"
#include "lhfont.h"
#include "tsfrontchar.h"
#include "tsfrontmap.h"
#include "ts2.h"
#include "fighterchar.h"
#include "fightermap.h"
#include "cursorchar.h"
#include "cursormap.h"
#include "wallpapermap.h"
#include "wallpaperchar.h"
#include "cpufightermap.h"
#include "cpufighterchar.h"
#include "killipede1map.h"
#include "killipede1char.h"
#include "giantmap.h"
#include "giantchar.h"
#include "rumblebeebgmap.h"
#include "rumblebeebgchar.h"
#include "youchar.h"
#include "youmap.h"
#include "cpuchar.h"
#include "cpumap.h"
#include "icoof.h"
#include "icow3.h"
#include "icmommy.h"

#include "cpu2char.h"
#include "cpu2map.h"
#include "you2char.h"
#include "you2map.h"

#include "wallpaper3map.h"
#include "wallpaper3char.h"


int cursorx=80, cursory=43, fighter=1, opponent=1, fighterx=60, fightery=40, a=0, b=0, c=0, d=0;
int opponentx=160, opponenty=40, e=0, getRandom=0,  scrolltimer=0, l=0, m=0, n=0, o=0, sfxtimer=0;
int opponentxplus=0, opponentyminus=0, opponentyplus=0, sound=0, opponentxminus=0, sfxmake=0;

int scroll=-192, scrolly=0;
int scroll2=112, scroll2y=-16;

int scroll3=-192, scroll3y=224;
int scroll4=112, scroll4y=208;

int currSong=1, SongTick=0, currNote=0, currNoteLength=1, song=1;
int TitleScreenSong=0;

int jump=0, fall=0, jumptimer=61, falltimer=0, moverand=0, oppdir=0, movetimer=0, movestop=0, movetimer2=0, moverand2=3;




//waveform RAM contents
u8 wave1[]={
0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F,
0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F, 0x3F
};

//~1.6 usec delay, count needs to be volatile or the optimizer basically removes this function
void delay1p6us(volatile int count)
{
	asm("
	1:
	add	-1,%0 /*decrement count*/
	cmp	0,%0 /*compare num with 0 to tell when done*/
	bgt	1b /*loop if count remaining is greater than 0*/
	"
	: /* No Output */
	: "r" (count) /* Input */
	/* :  no regs used */
	);
}

void init_speech()
{
  int i;
  
  SSTOP = 1; //stop all sounds
  
  for (i=0; i<32; i++) //copy waveform data
    WAVEDATA1[i<<2]=wave1[i];
  
  //turn off channels
  SND_REGS[0].SxINT = 0x00;
  SND_REGS[1].SxINT = 0x00;
  SND_REGS[2].SxINT = 0x00;
  SND_REGS[3].SxINT = 0x00;
  SND_REGS[4].SxINT = 0x00;
  SND_REGS[5].SxINT = 0x00;
  
  SSTOP = 0; //allow sounds

  //use Waveform RAM0
  SND_REGS[0].SxRAM = 0x00;
  SND_REGS[1].SxRAM = 0x00;
  SND_REGS[2].SxRAM = 0x00;
  SND_REGS[3].SxRAM = 0x00;
  SND_REGS[4].SxRAM = 0x00;
  
  //mute all
  SND_REGS[0].SxLRV = 0x00;
  SND_REGS[1].SxLRV = 0x00;
  SND_REGS[2].SxLRV = 0x00;
  SND_REGS[3].SxLRV = 0x00;
  SND_REGS[4].SxLRV = 0x00;
  SND_REGS[5].SxLRV = 0x00;
  
  //set initial envelope to max
  SND_REGS[0].SxEV0 = 0xF0;
  SND_REGS[1].SxEV0 = 0xF0;
  SND_REGS[2].SxEV0 = 0xF0;
  SND_REGS[3].SxEV0 = 0xF0;
  SND_REGS[4].SxEV0 = 0xF0;
  SND_REGS[5].SxEV0 = 0x00;
  
  //disable envelope
  SND_REGS[0].SxEV1 = 0x00;
  SND_REGS[1].SxEV1 = 0x00;
  SND_REGS[2].SxEV1 = 0x00;
  SND_REGS[3].SxEV1 = 0x00;
  SND_REGS[4].SxEV1 = 0x00;
  
  //set low freq (doesn't matter since waveform is DC)
  SND_REGS[0].SxFQL = 0x00;
  SND_REGS[1].SxFQL = 0x00;
  SND_REGS[2].SxFQL = 0x00;
  SND_REGS[3].SxFQL = 0x00;
  SND_REGS[4].SxFQL = 0x00;
  SND_REGS[0].SxFQH = 0x00;
  SND_REGS[1].SxFQH = 0x00;
  SND_REGS[2].SxFQH = 0x00;
  SND_REGS[3].SxFQH = 0x00;
  SND_REGS[4].SxFQH = 0x00;
  
  SND_REGS[0].SxINT = 0x80; //enable channel 1
}

//plays wav data passed in with parameters
void wavplay(const u8 *wav_data, int channels, int len, int delaytime)
{
  int i;

  if (channels == 1) //mono
  {
    for (i=0; i<len; i++)
    {
      if (!(i&1)) //first half of packed data
        SND_REGS[0].SxLRV=(wav_data[i>>1]&0xF0)|(wav_data[i>>1]>>4);
      else //second half of packed data
        SND_REGS[0].SxLRV=((wav_data[i>>1]&0x0F)<<4)|(wav_data[i>>1]&0x0F);
      delay1p6us(delaytime);
    }
  }
  else //stereo
  {
    for (i=0; i<len; i++)
    {
      SND_REGS[0].SxLRV=wav_data[i];
      delay1p6us(delaytime);
    }
  }
}

//divide this number by sample rate for delay
//feel free free to tweak to get sound just right
//or just hardcode the delay once you get it
#define SR_DIV 3330000

void PlayNote(u8 chan, u16 freq, u8 vol) { 
    //Set up the frequency the channel will play 
    SND_REGS[chan].SxFQH = freq >> 8; 
    SND_REGS[chan].SxFQL = freq & 0xFF; 

    //Set the volume for the channel (0-15, same for left/right) 
    SND_REGS[chan].SxLRV = (vol << 4) | vol; 

    //Envelope for the channel (makes the tone fade out) 
    SND_REGS[chan].SxEV0 = 0xF7; 
    SND_REGS[chan].SxEV1 = 0x01; 

    //Start the channel without interval 
    SND_REGS[chan].SxINT = 0x9F; 
} 



int main()

{
	copymem((void*)WAVEDATA1, (void*)PIANO, 128); 
	copymem ((void*)CharSeg3, (void*)LHFONT, 8192);
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);

	// while (vbReadPad()==0) { 
	// randomPointer++; 
	// } 
	// randomPointer %= 4; 

	vbDisplayOn();
	vbDisplayShow();




	
	
        vbTextOut(0, 20, 11,"IMPORTANT:");
        vbTextOut(0, 14, 12,"SCREW THE INSTRUCTION");
        vbTextOut(0, 13, 13,"AND PRECAUTION BOOKLETS");
        vbTextOut(0, 15, 14,"JUST PLAY THE GAME.");




	while(!(vbReadPad()&K_ANY)){}
	
	{
	u16 song[] = {F_2, C_3}; 
	u16 song2[] = {F_2, B_2}; 
	u16 song3[] = {B_2, C_3};
	u16 song4[] = {C_3, F_2};
	u32 SongTick = 0; 
	u8 currNote = 0; 	
	
	
	while(vbReadPad()&K_ANY){}



	copymem((void*)CharSeg1, (void*)TSFRONTCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)TSFRONTMAP, 256*16);	
	



	while(!(vbReadPad()&K_STA)){
	

	vbSetWorld(31, WRLD_ON|1, 0, 2, 0, 0, 0, 0, 384, 224);





	TitleScreenSong++;
	
	
	if (TitleScreenSong>4) TitleScreenSong=0, SongTick++;	




	if (SongTick>currNoteLength) {

	if (currNote==0) currNoteLength=200;
	if (currNote==1) currNoteLength=300;
	if (currSong==1) PlayNote(0, song[currNote], 8); 
	if (currSong==2) PlayNote(0, song2[currNote], 8);
	if (currSong==3) PlayNote(0, song3[currNote], 8); 
	if (currSong==4) PlayNote(0, song4[currNote], 8);	
	
	currNote++;



	


	if ((currSong==1) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==2) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==3) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==4) && (currNote>1)) currSong++, currNote=0;
	if (currSong==5) currSong=1, currNote=0;
	
	SongTick=0;
	}


	
	}

	copymem((void*)CharSeg2, (void*)WALLPAPER3CHAR, 256*16);
	copymem((void*)BGMap(2), (void*)WALLPAPER3MAP, 256*16);

	copymem((void*)CharSeg0, (void*)YOU2CHAR, 512*16);
	copymem((void*)BGMap(0), (void*)YOU2MAP, 512*16);

	copymem((void*)CharSeg1, (void*)CURSORCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)CURSORMAP, 256*16);		

	while(vbReadPad()&K_STA){
	
	

	



	
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|2, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|2, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|2, scroll, -3, scrolly, 0, 0, 0, 384, 224);	
	
	if (scrolltimer>20) scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	if (scrolltimer>20) scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;
	

	TitleScreenSong++;
	
	
	if (TitleScreenSong>4) TitleScreenSong=0, scrolltimer=scrolltimer+1, SongTick++;
	if (SongTick>currNoteLength) {

	if (currNote==0) currNoteLength=200;
	if (currNote==1) currNoteLength=300;
	
	if (currSong==1) PlayNote(0, song[currNote], 8); 
	if (currSong==2) PlayNote(0, song2[currNote], 8);
	if (currSong==3) PlayNote(0, song3[currNote], 8); 
	if (currSong==4) PlayNote(0, song4[currNote], 8);	
	
	currNote++;



	


	if ((currSong==1) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==2) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==3) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==4) && (currNote>1)) currSong++, currNote=0;
	if (currSong==5) currSong=1, currNote=0;
	
	SongTick=0;
	}
	
	}












  	//vbDisplayOn();
	//vbDisplayShow();



	while(!(vbReadPad()&K_STA)){
	scrolltimer=scrolltimer+1;

	
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(26, WRLD_ON|1, cursorx, 0, cursory, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|2, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|2, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|2, scroll, -3, scrolly, 0, 0, 0, 384, 224);	


	if (SongTick>currNoteLength) {
	if (currNote==0) currNoteLength=200;
	if (currNote==1) currNoteLength=300;

	if (currSong==1) PlayNote(0, song[currNote], 8); 
	if (currSong==2) PlayNote(0, song2[currNote], 8);
	if (currSong==3) PlayNote(0, song3[currNote], 8); 
	if (currSong==4) PlayNote(0, song4[currNote], 8);	
	
	currNote++;



	


	if ((currSong==1) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==2) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==3) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==4) && (currNote>1)) currSong++, currNote=0;
	if (currSong==5) currSong=1, currNote=0;
	
	SongTick=0;
	}


	

	
	
	if (fighter<5) cursory=47; else cursory=95;
	if (fighter==-1) fighter=8;
	if ((fighter<1) && (fighter>-1)) fighter=8; 
	if (fighter==-2) fighter=5;
	if (fighter==9) fighter=1;
	if (fighter==10) fighter=2;
	if (fighter==11) fighter=3;
	if (fighter==1) cursorx=89, vbTextOut(0, 15, 20,"      GI ANT    ");	
	if (fighter==2) cursorx=137, vbTextOut(0, 15, 20,"    BEHE MOTH   ");
	if (fighter==3) cursorx=185, vbTextOut(0, 15, 20,"    RUMBLEBEE   ");
	if (fighter==4) cursorx=233, vbTextOut(0, 15, 20," SLAYING MANTIS ");
	
    if (fighter==5) cursorx=89,  vbTextOut(0, 15, 20,"   MELEE-DYBUG  ");
	if (fighter==6) cursorx=137, vbTextOut(0, 15, 20,"    KILLIPEDE   ");
	if (fighter==7) cursorx=185, vbTextOut(0, 15, 20,"     SUPERFLY   ");
	if (fighter==8) cursorx=233, vbTextOut(0, 15, 20,"PANZER DRAGONFLY");
  
  
	if(vbReadPad()&K_LR)  l=l+1;
    if (l>30) fighter=fighter+1, l=0;
	
	if(vbReadPad()&K_LL)  m=m+1;
    if (m>30) fighter=fighter-1, m=0;	
	
	if(vbReadPad()&K_LU)  n=n+1;
    if (n>30) fighter=fighter-4, n=0;
	
	if(vbReadPad()&K_LD)  o=o+1;
    if (o>30) fighter=fighter+4, o=0;		
	
	
	//if((vbReadPad()&K_LL) && (l==1)) fighter=fighter-1; else l=0;
	//if((vbReadPad()&K_LU) && (l==1)) fighter=fighter-3; else l=0;
	//if((vbReadPad()&K_LD) && (l==1)) fighter=fighter+3; else l=0;
	
	
	if (scrolltimer>20) scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	if (scrolltimer>20) scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;
	
	
	SongTick++;	
	
	

	
	
	
	
	}
	
	
	copymem ((void*)CharSeg3, (void*)LHFONT, 8192);	
	
	copymem((void*)CharSeg0, (void*)CPU2CHAR, 512*16);
	copymem((void*)BGMap(0), (void*)CPU2MAP, 512*16);	
	
	copymem((void*)CharSeg2, (void*)WALLPAPER3CHAR, 256*16);
	copymem((void*)BGMap(2), (void*)WALLPAPER3MAP, 256*16);
	
	copymem((void*)CharSeg1, (void*)CURSORCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)CURSORMAP, 256*16);	

	
	while(vbReadPad()&K_STA){
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|2, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|2, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|2, scroll, -3, scrolly, 0, 0, 0, 384, 224);	

	

	if (scrolltimer>20) scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	if (scrolltimer>20) scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;
	
	TitleScreenSong++;
	
	
	if (TitleScreenSong>4) TitleScreenSong=0, scrolltimer=scrolltimer+1, SongTick++;
	if (SongTick>currNoteLength) {
	if (currNote==0) currNoteLength=200;
	if (currNote==1) currNoteLength=300;

	if (currSong==1) PlayNote(0, song[currNote], 8); 
	if (currSong==2) PlayNote(0, song2[currNote], 8);
	if (currSong==3) PlayNote(0, song3[currNote], 8); 
	if (currSong==4) PlayNote(0, song4[currNote], 8);	
	
	currNote++;



	


	if ((currSong==1) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==2) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==3) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==4) && (currNote>1)) currSong++, currNote=0;
	if (currSong==5) currSong=1, currNote=0;
	
	SongTick=0;
	}
	

	}

	while(!(vbReadPad()&K_STA)){
	
	
	
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(26, WRLD_ON|1, cursorx, 0, cursory, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|2, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|2, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|2, scroll, -3, scrolly, 0, 0, 0, 384, 224);	
	
	

	scrolltimer=scrolltimer+1;

	SongTick++;
  

	if(vbReadPad()&K_LR)  l=l+1;
    if (l>30) opponent=opponent+1, l=0;
	
	if(vbReadPad()&K_LL)  m=m+1;
    if (m>30) opponent=opponent-1, m=0;	
	
	if(vbReadPad()&K_LU)  n=n+1;
    if (n>30) opponent=opponent-4, n=0;
	
	if(vbReadPad()&K_LD)  o=o+1;
    if (o>30) opponent=opponent+4, o=0;	

	
	
	if (opponent<5) cursory=47; else cursory=95;
	if (opponent==-1) opponent=7;
	if ((opponent<1) && (opponent>-1)) opponent=8;
	if (opponent==-2) opponent=5;
	if (opponent==9) opponent=1;
	if (opponent==10) opponent=2;
	if (opponent==11) opponent=3;
	
    if (opponent==fighter) opponent=opponent+1;	
	
	if (opponent==1) cursorx=89, vbTextOut(0, 15, 20,"      GI ANT    ");	
	if (opponent==2) cursorx=137, vbTextOut(0, 15, 20,"    BEHE MOTH   ");
	if (opponent==3) cursorx=185, vbTextOut(0, 15, 20,"    RUMBLEBEE   ");
	if (opponent==4) cursorx=233, vbTextOut(0, 15, 20," SLAYING MANTIS ");
	
    if (opponent==5) cursorx=89,  vbTextOut(0, 15, 20,"   MELEE-DYBUG  ");
	if (opponent==6) cursorx=137, vbTextOut(0, 15, 20,"    KILLIPEDE   ");
	if (opponent==7) cursorx=185, vbTextOut(0, 15, 20,"     SUPERFLY   ");
	if (opponent==8) cursorx=233, vbTextOut(0, 15, 20,"PANZER DRAGONFLY");
	
	if (scrolltimer>20) scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	if (scrolltimer>20) scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;		
	
	if (SongTick>currNoteLength) {

	if (currNote==0) currNoteLength=200;
	if (currNote==1) currNoteLength=300;
	if (currSong==1) PlayNote(0, song[currNote], 8); 
	if (currSong==2) PlayNote(0, song2[currNote], 8);
	if (currSong==3) PlayNote(0, song3[currNote], 8); 
	if (currSong==4) PlayNote(0, song4[currNote], 8);	
	
	currNote++;



	


	if ((currSong==1) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==2) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==3) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==4) && (currNote>1)) currSong++, currNote=0;
	if (currSong==5) currSong=1, currNote=0;
	
	SongTick=0;
	}
	
	}
	
	
	copymem ((void*)CharSeg3, (void*)LHFONT, 8192);
	
	//copymem((void*)CharSeg0, (void*)CPU2CHAR, 512*16);
	//copymem((void*)BGMap(0), (void*)CPU2MAP, 512*16);	
		
	//copymem((void*)CharSeg2, (void*)WALLPAPER3CHAR, 256*16);
	//copymem((void*)BGMap(2), (void*)WALLPAPER3MAP, 256*16);
	
	//copymem((void*)CharSeg1, (void*)CURSORCHAR, 256*16);
	//copymem((void*)BGMap(1), (void*)CURSORMAP, 256*16);		
	
	
	
	while(vbReadPad()&K_STA){
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|2, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|2, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|2, scroll, -3, scrolly, 0, 0, 0, 384, 224);	
	
	if (scrolltimer>20) scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	if (scrolltimer>20) scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;
	

	TitleScreenSong++;
	
	
	if (TitleScreenSong>4) TitleScreenSong=0, scrolltimer=scrolltimer+1, SongTick++;
	if (SongTick>currNoteLength) {
	if (currNote==0) currNoteLength=200;
	if (currNote==1) currNoteLength=300;

	if (currSong==1) PlayNote(0, song[currNote], 8); 
	if (currSong==2) PlayNote(0, song2[currNote], 8);
	if (currSong==3) PlayNote(0, song3[currNote], 8); 
	if (currSong==4) PlayNote(0, song4[currNote], 8);	
	
	currNote++;



	


	if ((currSong==1) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==2) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==3) && (currNote>1)) currSong++, currNote=0;
	if ((currSong==4) && (currNote>1)) currSong++, currNote=0;
	if (currSong==5) currSong=1, currNote=0;
	
	SongTick=0;
	}
	
	}

	

	
	vbFXFadeOut(1);
	


	// vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
	// vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);
	// vbSetWorld(29, WRLD_ON|1, fighterx, 0, fightery, 0, 0, 0, 384, 224);
	
	copymem((void*)CharSeg1, (void*)KILLIPEDE1CHAR, 256*16);
	copymem((void*)BGMap(1), (void*)KILLIPEDE1MAP, 256*16);
	
	copymem((void*)CharSeg0, (void*)RUMBLEBEEBGCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)RUMBLEBEEBGMAP, 256*16);

	copymem((void*)CharSeg2, (void*)GIANTCHAR, 256*16);
	copymem((void*)BGMap(2), (void*)GIANTMAP, 256*16);	
	
	vbSetWorld(26, WRLD_ON|2, opponentx, 0, opponenty, 0, 0, 0, 384, 224);
	vbSetWorld(27, WRLD_ON|1, fighterx, 0, fightery, 0, 0, 0, 384, 224);
	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0); // temp
	vbSetWorld(29, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 384, 224);

  init_speech(); //initialize sound regs for speech
    
  VIP_REGS[BKCOL]=3; //tells that we've started

	
	vbFXFadeIn(1);
	
	

	

	
	
	
	
	
	while(1){
	
	
	
	e=e+1;
	
	
	
	if (fighter==1) vbTextOut(0, 1, 1,"GI ANT");
	if (fighter==2) vbTextOut(0, 1, 1,"BEHE MOTH");
	if (fighter==3) vbTextOut(0, 1, 1,"RUMBLEBEE");
	if (fighter==4) vbTextOut(0, 1, 1,"SLAYING MANTIS");
	if (fighter==5) vbTextOut(0, 1, 1,"MELEE-DYBUG");
	if (fighter==6) vbTextOut(0, 1, 1,"KILLIPEDE");
	if (fighter==7) vbTextOut(0, 1, 1,"SUPERFLY");	
	if (fighter==8) vbTextOut(0, 1, 1,"PANZER DRAGONFLY");
	
	if (opponent==1) vbTextOut(0, 41, 1,"GI ANT");
	if (opponent==2) vbTextOut(0, 38, 1,"BEHE MOTH");
	if (opponent==3) vbTextOut(0, 38, 1,"RUMBLEBEE");
	if (opponent==4) vbTextOut(0, 33, 1,"SLAYING MANTIS");
	if (opponent==5) vbTextOut(0, 36, 1,"MELEE-DYBUG");
	if (opponent==6) vbTextOut(0, 38, 1,"KILLIPEDE");
	if (opponent==7) vbTextOut(0, 39, 1,"SUPERFLY");
	if (opponent==8) vbTextOut(0, 31, 1,"PANZER DRAGONFLY");
	
	vbTextOut(0, 1, 2,",,,,,,,,,,,,,,,,");
	vbTextOut(0, 31, 2,",,,,,,,,,,,,,,,,");	

	
	
	
	vbSetWorld(26, WRLD_ON|2, opponentx, 0, opponenty, 0, 0, 0, 384, 224);
	vbSetWorld(27, WRLD_ON|1, fighterx, 0, fightery, 0, 0, 0, 384, 224);
	//vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0); // temp
	//vbSetWorld(29, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	//vbSetWorld(31, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 384, 224);

	



	
	opponentyminus=opponenty-10;
	opponentyplus=opponenty+25;
	opponentxminus=opponentx-40;
	opponentxplus=opponentx+40;
	
	
	if((vbReadPad()&K_LR) && (fighterx<320)) a=a+1;
	if (a>2) a=0, fighterx=fighterx+1; 
	
	if((vbReadPad()&K_LL) && (fighterx>30)) b=b+1;
	if (b>2) b=0, fighterx=fighterx-1;
	
	if((vbReadPad()&K_LD) && (fightery<110)) c=c+1;
	if (c>2) c=0, fightery=fightery+1; 
	
	if((vbReadPad()&K_LU) && (fightery>50)) d=d+1;
	if (d>2) d=0, fightery=fightery-1;

	if((vbReadPad()&K_A) && (jumptimer==61)) jump=1;
	if((!(vbReadPad()&K_A)) && (jump==1)) jump=2, falltimer=jumptimer, fall=1;
	
	if (fall==1) falltimer=falltimer+1, fightery=fightery+1;
	if ((fall==1) && (falltimer>60)) fall=0, falltimer=61, jumptimer=61;
	if ((fall==1) && (fightery>109)) fall=0, falltimer=61, jumptimer=61;
	
	

	
	sfxmake=0;

	
	if ((vbReadPad()&K_B) && (fighterx>opponentxminus) && (fighterx<opponentxplus) && (fightery>opponentyminus) && (fightery<opponentyplus) && (sfxtimer<30)) wavplay(icmommy, ICMOMMY_CH, ICMOMMY_LEN, SR_DIV/ICMOMMY_SR), VIP_REGS[BKCOL]^=3; 
  	if ((vbReadPad()&K_B) && (fighterx>opponentxminus) && (fighterx<opponentxplus) && (fightery>opponentyminus) && (fightery<opponentyplus) && (sfxtimer>29)) sfxmake=1; 
	if ((vbReadPad()&K_B) && (fighterx>opponentxminus) && (fighterx<opponentxplus) && (fightery>opponentyminus) && (fightery<opponentyplus) && (sfxtimer>59)) sfxmake=1; 
	
	
	if ((sfxmake==1) && (sfxtimer<59)) wavplay(icoof, ICOOF_CH, ICOOF_LEN, SR_DIV/ICOOF_SR), VIP_REGS[BKCOL]^=3; 
	if ((sfxmake==1) && (sfxtimer>58)) wavplay(icow3, ICOW3_CH, ICOW3_LEN, SR_DIV/ICOW3_SR), VIP_REGS[BKCOL]^=3;   

	if ((jumptimer>0) && (jump==1)) jumptimer=jumptimer-1, fightery=fightery-1;
	if ((jumptimer==0) && (fall==0)) falltimer=jumptimer, jump=0, fall=1;
	
	vbDisplayOn();
	vbDisplayShow();
	sfxtimer++;
	if (sfxtimer>89) sfxtimer=0;

	vbSetWorld(28, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0); // temp
	vbSetWorld(29, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 384, 224);



	//while(vbReadPad()&K_STA){}
	

	
}
}
}

